//+------------------------------------------------------------------+
//|                     Kaufman Adaptive Moving Average with signals |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_width2 2
#property indicator_width3 2

//
//
//
//
//

extern int    AMAPeriod       = 26;
extern int    AMAPrice        = PRICE_CLOSE;
extern int    Nfast           = 5;
extern int    Nslow           = 20;
extern double GCoeff          = 2.0;
extern double dK              = 2.0; 

//
//
//
//
//

double kAMAbuffer[];
double kAMAupsig[];
double kAMAdownsig[];
double diff[];

//
//
//
//
//

double fastend;
double slowend;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,kAMAbuffer);
   SetIndexBuffer(1,kAMAupsig);   SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,kAMAdownsig); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,diff);
   
   
   //
   //
   //
   //
   //
   
      fastend   = (2.0 /(Nfast + 1));
      slowend   = (2.0 /(Nslow + 1));
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("Kaufman AMA signals ("+AMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

           //
           //
           //
           //
           //
                      
           if (Digits==3 || Digits==5)
              double _point=Point*10;
           else      _point=Point;         


   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i);

         if (i > Bars-AMAPeriod) { kAMAbuffer[i] = price; continue; }
   
         //
         //
         //
         //
         //
   
         double efratio = 1.00;
         double noise   = 0.00;
         double smooth;
         double signal;
             signal  = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i+AMAPeriod));
             diff[i] = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i+1));
                for (int k=0;k<AMAPeriod;k++)
                        noise += diff[i+k];

          //
          //
          //
          //
          //

          if (noise != 0) efratio = signal/noise;
                          smooth        = MathPow(efratio*(fastend-slowend)+slowend,GCoeff);
                          kAMAbuffer[i] = kAMAbuffer[i+1] + smooth*(price-kAMAbuffer[i+1]);

          //
          //
          //
          //
          //
                                    
         kAMAupsig[i]   = EMPTY_VALUE;
         kAMAdownsig[i] = EMPTY_VALUE;
            double ddK=kAMAbuffer[i] - kAMAbuffer[i+1];
               if ((MathAbs(ddK)) > (dK*_point) && (ddK > 0)) kAMAupsig[i]   = kAMAbuffer[i];
               if ((MathAbs(ddK)) > (dK*_point) && (ddK < 0)) kAMAdownsig[i] = kAMAbuffer[i];
                             
   }
   return(0);
}